// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIMessages;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.myfaces.tobago.component.MethodBindingToMethodExpression;
import org.apache.myfaces.tobago.component.MethodExpressionToMethodBinding;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders error/validation messages.
  * UIComponent class, generated from template {@code component1.2.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.MessagesTagDeclaration}.
 */
public class UIMessages
    extends AbstractUIMessages implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Messages";

  private org.apache.myfaces.tobago.context.Markup markup;
  private java.lang.Boolean showSummary;
  private org.apache.myfaces.tobago.component.UIMessages.OrderBy orderBy;
  private java.lang.String globalOnly;
  private org.apache.myfaces.tobago.layout.Measure marginLeft;
  private java.lang.String forComponent;
  private org.apache.myfaces.tobago.layout.Measure minimumHeight;
  private javax.faces.application.FacesMessage.Severity maxSeverity;
  private javax.faces.application.FacesMessage.Severity minSeverity;
  private org.apache.myfaces.tobago.layout.Measure height;
  private org.apache.myfaces.tobago.layout.Measure minimumWidth;
  private java.lang.Integer rowSpan;
  private java.lang.Boolean confirmation;
  private org.apache.myfaces.tobago.layout.Measure left;
  private java.lang.Integer columnSpan;
  private org.apache.myfaces.tobago.layout.Measure maximumHeight;
  private org.apache.myfaces.tobago.layout.Measure top;
  private org.apache.myfaces.tobago.layout.Measure currentWidth;
  private org.apache.myfaces.tobago.layout.Measure marginTop;
  private org.apache.myfaces.tobago.layout.Measure marginRight;
  private org.apache.myfaces.tobago.layout.Measure width;
  private org.apache.myfaces.tobago.layout.Measure currentHeight;
  private org.apache.myfaces.tobago.layout.Measure preferredHeight;
  private java.lang.Boolean showDetail;
  private org.apache.myfaces.tobago.layout.Display display;
  private org.apache.myfaces.tobago.layout.Measure maximumWidth;
  private org.apache.myfaces.tobago.layout.Measure preferredWidth;
  private org.apache.myfaces.tobago.layout.Measure marginBottom;
  private java.lang.Integer verticalIndex;
  private org.apache.myfaces.tobago.context.Markup currentMarkup;
  private java.lang.Integer horizontalIndex;
  private java.lang.Integer maxNumber;


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    if (markup != null) {
      return markup;
    }
    ValueExpression ve = getValueExpression("markup");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Markup.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    this.markup = markup;
  }

  /**
  Flag indicating whether the summary should be included
  <br />Default: <code>true</code>
  */
  public boolean isShowSummary() {
    if (showSummary != null) {
      return showSummary;
    }
    ValueExpression ve = getValueExpression("showSummary");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return true;
  }

  public void setShowSummary(boolean showSummary) {
    this.showSummary = showSummary;
  }

  /**
  Sets the order of the messages.
  <br />Default: <code>occurrence</code><br />Allowed Values: <code>occurrence,severity</code>
  */
  public org.apache.myfaces.tobago.component.UIMessages.OrderBy getOrderBy() {
    if (orderBy != null) {
      return orderBy;
    }
    ValueExpression ve = getValueExpression("orderBy");
    if (ve != null) {
      try {
        org.apache.myfaces.tobago.component.UIMessages.OrderBy orderBy = (org.apache.myfaces.tobago.component.UIMessages.OrderBy) ve.getValue(getFacesContext().getELContext());
        if (orderBy != null) {
          return orderBy;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return org.apache.myfaces.tobago.internal.component.AbstractUIMessages.OrderBy.OCCURRENCE;
  }

  public void setOrderBy(org.apache.myfaces.tobago.component.UIMessages.OrderBy orderBy) {
    this.orderBy = orderBy;
  }

  /**
  Flag indicating that only messages that are not associated to any
   particular UIComponent should be displayed. That are messages without clientId.
  <br />Default: <code>false</code>
  */
  public java.lang.String getGlobalOnly() {
    if (globalOnly != null) {
      return globalOnly;
    }
    ValueExpression ve = getValueExpression("globalOnly");
    if (ve != null) {
      try {
        java.lang.String globalOnly = (java.lang.String) ve.getValue(getFacesContext().getELContext());
        if (globalOnly != null) {
          return globalOnly;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return "false";
  }

  public void setGlobalOnly(java.lang.String globalOnly) {
    this.globalOnly = globalOnly;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    if (marginLeft != null) {
      return marginLeft;
    }
    ValueExpression ve = getValueExpression("marginLeft");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this);
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    this.marginLeft = marginLeft;
  }

  /**
  Id of the component, this is related to.

  */
  public java.lang.String getFor() {
    if (forComponent != null) {
      return forComponent;
    }
    ValueExpression ve = getValueExpression("for");
    if (ve != null) {
      try {
        return (java.lang.String) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setFor(java.lang.String forComponent) {
    this.forComponent = forComponent;
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    if (minimumHeight != null) {
      return minimumHeight;
    }
    ValueExpression ve = getValueExpression("minimumHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this);
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    this.minimumHeight = minimumHeight;
  }

  /**
  Sets the maximum severity to be shown. E. g. "warn" shows only "warn" and "info".
   When setting this attribute you usually shoud take care, that you have a second message tag to show the
   higher severity levels.
  <br />Default: <code>fatal</code>
  */
  public javax.faces.application.FacesMessage.Severity getMaxSeverity() {
    if (maxSeverity != null) {
      return maxSeverity;
    }
    ValueExpression ve = getValueExpression("maxSeverity");
    if (ve != null) {
      try {
        javax.faces.application.FacesMessage.Severity maxSeverity = (javax.faces.application.FacesMessage.Severity) ve.getValue(getFacesContext().getELContext());
        if (maxSeverity != null) {
          return maxSeverity;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return javax.faces.application.FacesMessage.SEVERITY_FATAL;
  }

  public void setMaxSeverity(javax.faces.application.FacesMessage.Severity maxSeverity) {
    this.maxSeverity = maxSeverity;
  }

  /**
  Sets the mininum severity to be shown. E. g. "warn" shows only "warn", "error" and "fatal".
  <br />Default: <code>info</code>
  */
  public javax.faces.application.FacesMessage.Severity getMinSeverity() {
    if (minSeverity != null) {
      return minSeverity;
    }
    ValueExpression ve = getValueExpression("minSeverity");
    if (ve != null) {
      try {
        javax.faces.application.FacesMessage.Severity minSeverity = (javax.faces.application.FacesMessage.Severity) ve.getValue(getFacesContext().getELContext());
        if (minSeverity != null) {
          return minSeverity;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return javax.faces.application.FacesMessage.SEVERITY_INFO;
  }

  public void setMinSeverity(javax.faces.application.FacesMessage.Severity minSeverity) {
    this.minSeverity = minSeverity;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    if (height != null) {
      return height;
    }
    ValueExpression ve = getValueExpression("height");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this);
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    this.height = height;
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    if (minimumWidth != null) {
      return minimumWidth;
    }
    ValueExpression ve = getValueExpression("minimumWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer)getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this);
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    this.minimumWidth = minimumWidth;
  }

  public java.lang.Integer getRowSpan() {
    if (rowSpan != null) {
      return rowSpan;
    }
    ValueExpression ve = getValueExpression("rowSpan");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    this.rowSpan = rowSpan;
  }

  /**
  Has the user to confirm this message?
   This attributes handles the case, if the application wants to warn the user about a problem,
   and the user has to confirm the message before he/she can continue.
  <br />Default: <code>false</code>
  */
  public boolean isConfirmation() {
    if (confirmation != null) {
      return confirmation;
    }
    ValueExpression ve = getValueExpression("confirmation");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setConfirmation(boolean confirmation) {
    this.confirmation = confirmation;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    if (left != null) {
      return left;
    }
    ValueExpression ve = getValueExpression("left");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    this.left = left;
  }

  public java.lang.Integer getColumnSpan() {
    if (columnSpan != null) {
      return columnSpan;
    }
    ValueExpression ve = getValueExpression("columnSpan");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    this.columnSpan = columnSpan;
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    if (maximumHeight != null) {
      return maximumHeight;
    }
    ValueExpression ve = getValueExpression("maximumHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this);
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    this.maximumHeight = maximumHeight;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    if (top != null) {
      return top;
    }
    ValueExpression ve = getValueExpression("top");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    this.top = top;
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    if (currentWidth != null) {
      return currentWidth;
    }
    ValueExpression ve = getValueExpression("currentWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    this.currentWidth = currentWidth;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    if (marginTop != null) {
      return marginTop;
    }
    ValueExpression ve = getValueExpression("marginTop");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this);
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    this.marginTop = marginTop;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    if (marginRight != null) {
      return marginRight;
    }
    ValueExpression ve = getValueExpression("marginRight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this);
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    this.marginRight = marginRight;
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    if (width != null) {
      return width;
    }
    ValueExpression ve = getValueExpression("width");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this);
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    this.width = width;
  }

  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    if (currentHeight != null) {
      return currentHeight;
    }
    ValueExpression ve = getValueExpression("currentHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    this.currentHeight = currentHeight;
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    if (preferredHeight != null) {
      return preferredHeight;
    }
    ValueExpression ve = getValueExpression("preferredHeight");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this);
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    this.preferredHeight = preferredHeight;
  }

  /**
  Flag indicating whether the detail should be included
  <br />Default: <code>false</code>
  */
  public boolean isShowDetail() {
    if (showDetail != null) {
      return showDetail;
    }
    ValueExpression ve = getValueExpression("showDetail");
    if (ve != null) {
      try {
        Boolean bool = (Boolean) ve.getValue(getFacesContext().getELContext());
        if (bool != null) {
          return bool;
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return false;
  }

  public void setShowDetail(boolean showDetail) {
    this.showDetail = showDetail;
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    if (display != null) {
      return display;
    }
    ValueExpression ve = getValueExpression("display");
    if (ve != null) {
      try {
        return (org.apache.myfaces.tobago.layout.Display) ve.getValue(getFacesContext().getELContext());
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    this.display = display;
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    if (maximumWidth != null) {
      return maximumWidth;
    }
    ValueExpression ve = getValueExpression("maximumWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this);
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    this.maximumWidth = maximumWidth;
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    if (preferredWidth != null) {
      return preferredWidth;
    }
    ValueExpression ve = getValueExpression("preferredWidth");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this);
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    this.preferredWidth = preferredWidth;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    if (marginBottom != null) {
      return marginBottom;
    }
    ValueExpression ve = getValueExpression("marginBottom");
    if (ve != null) {
      try {
        Object object = ve.getValue(getFacesContext().getELContext());
        return Measure.valueOf(object);
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this);
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    this.marginBottom = marginBottom;
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    if (verticalIndex != null) {
      return verticalIndex;
    }
    ValueExpression ve = getValueExpression("verticalIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    this.verticalIndex = verticalIndex;
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    if (horizontalIndex != null) {
      return horizontalIndex;
    }
    ValueExpression ve = getValueExpression("horizontalIndex");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    this.horizontalIndex = horizontalIndex;
  }

  /**
  Sets the maximum number of messages to show.
  <br />Default: <code>2147483647</code>
  */
  public java.lang.Integer getMaxNumber() {
    if (maxNumber != null) {
      return maxNumber;
    }
    ValueExpression ve = getValueExpression("maxNumber");
    if (ve != null) {
      try {
        Number number = (Number) ve.getValue(getFacesContext().getELContext());
        if (number != null) {
          return number.intValue();
        }
      } catch (ELException e) {
  		  throw new FacesException(e);
  	  }
    }
    return 2147483647;
  }

  public void setMaxNumber(java.lang.Integer maxNumber) {
    this.maxNumber = maxNumber;
  }

  public void restoreState(FacesContext context, Object componentState) {
    Object[] values = (Object[]) componentState;
    super.restoreState(context, values[0]);
    markup = (org.apache.myfaces.tobago.context.Markup) values[1];
    showSummary = (java.lang.Boolean) values[2];
    orderBy = (org.apache.myfaces.tobago.component.UIMessages.OrderBy) values[3];
    globalOnly = (java.lang.String) values[4];
    marginLeft = (org.apache.myfaces.tobago.layout.Measure) values[5];
    forComponent = (java.lang.String) values[6];
    minimumHeight = (org.apache.myfaces.tobago.layout.Measure) values[7];
    maxSeverity = (javax.faces.application.FacesMessage.Severity) values[8];
    minSeverity = (javax.faces.application.FacesMessage.Severity) values[9];
    height = (org.apache.myfaces.tobago.layout.Measure) values[10];
    minimumWidth = (org.apache.myfaces.tobago.layout.Measure) values[11];
    rowSpan = (java.lang.Integer) values[12];
    confirmation = (java.lang.Boolean) values[13];
    left = (org.apache.myfaces.tobago.layout.Measure) values[14];
    columnSpan = (java.lang.Integer) values[15];
    maximumHeight = (org.apache.myfaces.tobago.layout.Measure) values[16];
    top = (org.apache.myfaces.tobago.layout.Measure) values[17];
    currentWidth = (org.apache.myfaces.tobago.layout.Measure) values[18];
    marginTop = (org.apache.myfaces.tobago.layout.Measure) values[19];
    marginRight = (org.apache.myfaces.tobago.layout.Measure) values[20];
    width = (org.apache.myfaces.tobago.layout.Measure) values[21];
    currentHeight = (org.apache.myfaces.tobago.layout.Measure) values[22];
    preferredHeight = (org.apache.myfaces.tobago.layout.Measure) values[23];
    showDetail = (java.lang.Boolean) values[24];
    display = (org.apache.myfaces.tobago.layout.Display) values[25];
    maximumWidth = (org.apache.myfaces.tobago.layout.Measure) values[26];
    preferredWidth = (org.apache.myfaces.tobago.layout.Measure) values[27];
    marginBottom = (org.apache.myfaces.tobago.layout.Measure) values[28];
    verticalIndex = (java.lang.Integer) values[29];
    horizontalIndex = (java.lang.Integer) values[30];
    maxNumber = (java.lang.Integer) values[31];
  }

  public Object saveState(FacesContext context) {
    Object[] values = new Object[32];
    values[0] = super.saveState(context);
    values[1] = markup;
    values[2] = showSummary;
    values[3] = orderBy;
    values[4] = globalOnly;
    values[5] = marginLeft;
    values[6] = forComponent;
    values[7] = minimumHeight;
    values[8] = maxSeverity;
    values[9] = minSeverity;
    values[10] = height;
    values[11] = minimumWidth;
    values[12] = rowSpan;
    values[13] = confirmation;
    values[14] = left;
    values[15] = columnSpan;
    values[16] = maximumHeight;
    values[17] = top;
    values[18] = currentWidth;
    values[19] = marginTop;
    values[20] = marginRight;
    values[21] = width;
    values[22] = currentHeight;
    values[23] = preferredHeight;
    values[24] = showDetail;
    values[25] = display;
    values[26] = maximumWidth;
    values[27] = preferredWidth;
    values[28] = marginBottom;
    values[29] = verticalIndex;
    values[30] = horizontalIndex;
    values[31] = maxNumber;
    currentMarkup = null;
    return values;
  }


}